# on PATH and environment=: https://github.com/Supervisor/supervisor/issues/787

[supervisord]
nodaemon=false
pidfile=/tmp/supervisor.pid
#logfile=/dev/stdout
#stdout_logfile_maxbytes=0
logfile=/var/log/supervisor.log
environment=LC_ALL="en_US.UTF-8",LC_CTYPE="en_US.UTF-8"

[unix_http_server]
file=/var/supervisor.sock
chmod=0700

[rpcinterface:supervisor]
supervisor.rpcinterface_factory=supervisor.rpcinterface:make_main_rpcinterface

[supervisorctl]
serverurl=unix:///var/supervisor.sock

[program:postgres]
command=/vcpipe/ops/pg_startup
environment=PGDATA=/data,LC_ALL="en_US.UTF-8",LC_CTYPE="en_US.UTF-8"
redirect_stderr=true
stdout_logfile=/var/log/supervisor-postgres.log
stdout_logfile_maxbytes=0

[program:auto-migrate]
command=/vcpipe/ops/auto-migrate
environment=DB_URL="postgresql:///postgres"
redirect_stderr=true
stdout_logfile=/var/log/supervisor-auto-migrate.log
stdout_logfile_maxbytes=0

[group:vcpipe]
programs=executor,webui

[program:webui]
#command=/vcpipe/exe/webui
command=pipenv run python /vcpipe/src/executor/webui_main.py
environment=DB_URL="postgresql:///postgres",PYTHONIOENCODING="utf-8",PYTHONUNBUFFERED="true",LC_ALL="en_US.UTF8",LC_CTYPE="en_US.UTF8"
# in shell when starting manually: export DB_URL="postgresql:///postgres" PYTHONIOENCODING="utf-8" PYTHONUNBUFFERED="true"
directory=/vcpipe
redirect_stderr=true
stdout_logfile=/var/log/supervisor-webui.log
stdout_logfile_maxbytes=0
# start manually after knowing that postgres is running and accepting connections
autostart=false

[program:executor]

command = /bin/bash -c 'source /vcpipe/exe/setup.source; pipenv run python /vcpipe/src/executor/executor_main.py'
environment = PATH=/vcpipe/exe/pipeline:/vcpipe/exe/qc:/vcpipe/exe/util:%(ENV_PATH)s,
    DB_URL="postgresql:///postgres",
    PYTHONUNBUFFERED="true",
    LC_ALL="en_US.UTF-8",
    LC_CTYPE="en_US.UTF-8"
directory=/vcpipe
redirect_stderr=true
stdout_logfile=/var/log/supervisor-executor.log
stdout_logfile_maxbytes=0
# start manually after knowing that postgres is running and accepting connections
autostart=false